diff -ru 5.2.3/app/controllers/CControllerAutoregUpdate.php dev/app/controllers/CControllerAutoregUpdate.php
--- 5.2.3/app/controllers/CControllerAutoregUpdate.php  2020-12-21 08:23:40.000000000 +0100
+++ dev/app/controllers/CControllerAutoregUpdate.php    2021-01-21 08:29:59.299697786 +0100
@@ -23,7 +23,9 @@

    protected function checkInput() {
        $fields = [
-           'tls_accept' =>             'in '.HOST_ENCRYPTION_NONE.','.HOST_ENCRYPTION_PSK.','.(HOST_ENCRYPTION_NONE | HOST_ENCRYPTION_PSK),
+           'tls_accept' =>             'in '.HOST_ENCRYPTION_NONE.','.HOST_ENCRYPTION_PSK.','.HOST_ENCRYPTION_CERTIFICATE.
+               ','.(HOST_ENCRYPTION_NONE | HOST_ENCRYPTION_PSK ).','.(HOST_ENCRYPTION_NONE | HOST_ENCRYPTION_CERTIFICATE ).','.(HOST_ENCRYPTION_PSK | HOST_ENCRYPTION_CERTIFICATE ).
+               ','.(HOST_ENCRYPTION_NONE | HOST_ENCRYPTION_PSK | HOST_ENCRYPTION_CERTIFICATE ),
            'tls_psk_identity' =>       'db config_autoreg_tls.tls_psk_identity',
            'tls_psk' =>                'db config_autoreg_tls.tls_psk'
        ];
Only in dev/app/controllers: .CControllerAutoregUpdate.php.swp
Only in dev/app/controllers: CControllerWidgetItemDataView.php
Only in dev/app/partials: itemdata.table.php
Only in dev/app/partials: .itemdata.table.php.swp
diff -ru 5.2.3/app/views/administration.autoreg.edit.php dev/app/views/administration.autoreg.edit.php
--- 5.2.3/app/views/administration.autoreg.edit.php 2020-12-14 11:27:18.000000000 +0100
+++ dev/app/views/administration.autoreg.edit.php   2021-01-21 08:01:57.537164034 +0100
@@ -48,6 +48,9 @@
                ->setLabel(_('No encryption'))
            )
            ->addItem((new CCheckBox('tls_in_psk'))->setLabel(_('PSK')))
+           ->addItem((new CCheckBox('tls_in_cert'))
+               ->setLabel(_('Certificate'))
+           )
    );

 if ($data['change_psk']) {
Only in dev/app/views: .administration.autoreg.edit.php.swp
diff -ru 5.2.3/app/views/js/administration.autoreg.edit.js.php dev/app/views/js/administration.autoreg.edit.js.php
--- 5.2.3/app/views/js/administration.autoreg.edit.js.php   2020-12-14 11:27:18.000000000 +0100
+++ dev/app/views/js/administration.autoreg.edit.js.php 2021-01-21 08:34:57.887678402 +0100
@@ -38,6 +38,9 @@
        else {
            $tls_psk.hide();
        }
+       if (($('#tls_accept').val() & <?= HOST_ENCRYPTION_CERTIFICATE ?>) == <?= HOST_ENCRYPTION_CERTIFICATE ?>) {
+           $('#tls_in_cert').prop('checked', true);
+       }

        // Show/hide PSK fields.
        $('#tls_in_psk').on('click', function() {
@@ -54,6 +57,9 @@
            if ($('#tls_in_psk').is(':checked')) {
                tls_accept |= <?= HOST_ENCRYPTION_PSK ?>;
            }
+           if ($('#tls_in_cert').is(':checked')) {
+               tls_accept |= <?= HOST_ENCRYPTION_CERTIFICATE ?>;
+           }
            else {
                $('#tls_psk_identity, #tls_psk').val('');
            }
Only in dev/app/views/js: .administration.autoreg.edit.js.php.swp
Only in dev/app/views: monitoring.widget.itemdata.view.php
Only in dev/app/views: .monitoring.widget.itemdata.view.php.swp
Only in dev/assets/fonts: graphfont.ttf
diff -ru 5.2.3/include/classes/api/services/CAutoregistration.php dev/include/classes/api/services/CAutoregistration.php
--- 5.2.3/include/classes/api/services/CAutoregistration.php    2020-12-21 08:23:40.000000000 +0100
+++ dev/include/classes/api/services/CAutoregistration.php  2021-01-21 08:32:34.235831362 +0100
@@ -122,7 +122,7 @@
     */
    protected function validateUpdate(array &$autoreg, array &$db_autoreg = null) {
        $api_input_rules = ['type' => API_OBJECT, 'flags' => API_NOT_EMPTY, 'fields' => [
-           'tls_accept' =>         ['type' => API_INT32, 'in' => HOST_ENCRYPTION_NONE.':'.(HOST_ENCRYPTION_NONE | HOST_ENCRYPTION_PSK)],
+           'tls_accept' =>         ['type' => API_INT32, 'in' => HOST_ENCRYPTION_NONE.':'.(HOST_ENCRYPTION_NONE | HOST_ENCRYPTION_PSK | HOST_ENCRYPTION_CERTIFICATE)],
            'tls_psk_identity' =>   ['type' => API_STRING_UTF8, 'length' => DB::getFieldLength('config_autoreg_tls', 'tls_psk_identity')],
            'tls_psk' =>            ['type' => API_PSK, 'length' => DB::getFieldLength('config_autoreg_tls', 'tls_psk')]
        ]];